package file.sr;
import java.io.IOException;
import java.net.DatagramPacket;
import java.net.InetAddress;

public class SenderX {

	String fileName;
	InetAddress ip;
	Integer contador;
	Long startTime;

	public SenderX(String fileName, InetAddress ip, Integer contador, Long startTime) {
		this.fileName = fileName;
		this.ip = ip;
		this.contador = 0;
		this.startTime = 0L;
	}

	public void start() throws InterruptedException, IOException {

		Sender send = new Sender(fileName, 5001, 3000, ip);

		// iniciar conexao
		Thread acks = new Thread(new receiveAckThread(send.sender, send, contador, startTime));
		acks.start();
		
		send.listSender.atualizarPrimeiraMetade();
		send.listSender.atualizarSegundaMetade();
		
		boolean fim = false;

		while (!fim) {

			while (send.nextSeqNum < send.sendBase + send.WINDOW_SIZE) {

				Pacote pacote = null;

				if (send.nextSeqNum < send.listSender.numberOfPackets) {
					pacote = send.listSender.arrayDePacotes[send.nextSeqNum%100];
					send.nextSeqNum++;

					if (pacote.getIsLastPacket() == 1) {
						fim = true;
						System.out.println("Ultimo pacote enviado");
					}
				}

				if (pacote != null) {
					Thread bla = new Thread(new sendThread(pacote, send.sender,
							send.ipDoReceiver, send.portaDoReceiver, send));
					bla.start();

					send.tabela.put(pacote.getPacketNumber(), bla);// coloca o
					// thread do
					// pacote numa

					bla.join();
					
					if (pacote.getIsLastPacket() == 1) {
						break;
					}
				}
				// tabela

				// acks.join();
				// bla.join();
			}

			while (send.listSender.arrayDePacotes[send.sendBase%100].estado == 2) {
				send.sendBase++;
				
				if(send.sendBase%50==0 && send.sendBase%100!=0){
					send.listSender.atualizarPrimeiraMetade();
				}else if( send.sendBase%100==0){
					send.listSender.atualizarSegundaMetade();
				}
			
			}

		}
		
		send.sender.close();

	}

}
