package file.sr;
import java.io.IOException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.UnknownHostException;
import java.util.concurrent.ConcurrentHashMap;

public class receiveAckThread implements Runnable {

	DatagramSocket socket;
	Integer contador;
	Sender send;// para alterar os valores sendBase/nextseqnum;
	Long startTime;

	public receiveAckThread(DatagramSocket socket, Sender send, Integer contador, Long startTime)
			throws UnknownHostException {
		this.socket = socket;
		this.send = send;
		this.contador = contador;
		this.startTime = startTime;
	}

	public static final int byteArrayToInt(byte[] b) {
		return (b[0] << 24) + ((b[1] & 0xFF) << 16) + ((b[2] & 0xFF) << 8)
				+ (b[3] & 0xFF);
	}

	public void run() {
		boolean roda = true;


		while (roda) {
			byte[] dados = new byte[5];
			DatagramPacket datagramPacket = new DatagramPacket(dados,
					dados.length);
			try {
				socket.receive(datagramPacket);
				contador++;
				byte[] ackNumber = new byte[4];
				ackNumber[0] = dados[0];
				ackNumber[1] = dados[1];
				ackNumber[2] = dados[2];
				ackNumber[3] = dados[3];
				int jacare = byteArrayToInt(ackNumber);
				// System.out.println("ackRecebido " + jacare);

				try {
					send.tabela.get(jacare).interrupt();
					send.listSender.arrayDePacotes[jacare%100].estado = 2;
					send.tabela.remove(send.tabela.get(jacare));
				} catch (Exception e) {

				}
				if (dados[4] == 1) {
					roda = false;
					System.out.println("AckThread Terminado");
				}
			} catch (IOException e) {

			}
		}

	}
}
