package net;

import java.net.DatagramPacket;

import java.util.concurrent.ArrayBlockingQueue;

public abstract class Socket extends Thread{
	private final int BUFFER_SIZE = 5;
	protected Transport transport;
	protected ArrayBlockingQueue<DatagramPacket> buffer;
	protected int id;
	
	public Socket(Transport transport, int id){
		this.transport = transport;
		this.id = id;
		buffer = new ArrayBlockingQueue<DatagramPacket> (BUFFER_SIZE);
	}
	public ArrayBlockingQueue<DatagramPacket> getBuffer(){
		return this.buffer;
	}
	public int getIdSocket(){
		return this.id;
	}

}
