package file.sr;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.SocketException;
import java.net.UnknownHostException;

public class ReceiverX {

	String fileName;
	InetAddress ip;
	Integer contador;
	Long startTime;

	public ReceiverX(String fileName, InetAddress ip, Integer contador, Long startTime) {
		this.fileName = fileName;
		this.ip = ip;
		this.contador = contador;
		this.startTime = startTime;
		this.contador = 0;
		this.startTime = 0L;
	}

	public static final int byteArrayToInt(byte[] b) {
		return (b[0] << 24) + ((b[1] & 0xFF) << 16) + ((b[2] & 0xFF) << 8)
				+ (b[3] & 0xFF);
	}

	public void start() throws IOException {

		// InetAddress ip = InetAddress.getByName("localhost");
		Receiver receiver = new Receiver(fileName, 3000, 5001, ip);

		boolean fim = false;

		Thread buf = new Thread(new bufferThread(receiver));
		buf.start();

		int tempoTotal = 0;
		int tempoFinal = 0;
		boolean primeiro = true;

		int contadorDaJanelaDoReceptor = 0;

		while (!fim) {
			// recebe um pacote
			byte[] dados = new byte[5009];
			DatagramPacket datagramPacket = new DatagramPacket(dados,
					dados.length);
			receiver.receiverSocket.receive(datagramPacket);
			if(contador==0){
				startTime = System.currentTimeMillis();
			}
			contador++;


			if (primeiro) {
				tempoTotal = (int) System.currentTimeMillis();
				primeiro = false;
			}

			// checa o numero do pacote e passa pra int
			byte[] numeroDoPacote = new byte[5];
			numeroDoPacote[0] = dados[0];
			numeroDoPacote[1] = dados[1];
			numeroDoPacote[2] = dados[2];
			numeroDoPacote[3] = dados[3];

			int numeroDoPacotez = byteArrayToInt(numeroDoPacote);

			// cria o pacote de ack e envia com o numero desse pacote

			if (numeroDoPacotez < contadorDaJanelaDoReceptor
					+ receiver.WINDOW_SIZE) {

				// se aquela posicao do buffer t vazia, salva o pacotinho nessa
				// posicao
				if (receiver.receiverBuffer[numeroDoPacotez
						% receiver.WINDOW_SIZE] == null) {
					receiver.receiverBuffer[numeroDoPacotez
							% receiver.WINDOW_SIZE] = new Pacotinho(dados);
					
					try{
					while (receiver.receiverBuffer[contadorDaJanelaDoReceptor
							% receiver.WINDOW_SIZE].estado == 2) {
						receiver.receiverBuffer[contadorDaJanelaDoReceptor
								% receiver.WINDOW_SIZE] = null;
						contadorDaJanelaDoReceptor++;
					}
					}catch(Exception e ){}
				}

				if (dados[8] == 0) {
					DatagramPacket ackPacket = new DatagramPacket(
							numeroDoPacote, numeroDoPacote.length,
							receiver.ipDoSender, receiver.portaDoSender);
					receiver.receiverSocket.send(ackPacket);
				} else {
					numeroDoPacote[4] = 1;
					DatagramPacket ackPacket = new DatagramPacket(
							numeroDoPacote, numeroDoPacote.length,
							receiver.ipDoSender, receiver.portaDoSender);
					receiver.receiverSocket.send(ackPacket);
					tempoFinal = (int) System.currentTimeMillis();
					tempoFinal = tempoFinal - tempoTotal;
					System.out.println(tempoFinal);
					fim = true;
				}

			}
			if (dados[8] == 1) {
				
			}
		}
	}
}
